function handler = penduloinvertido_desenhar(StrEstado,StrParametros,n,NFig,handler);

x = StrEstado.x(n);
theta = StrEstado.theta(n);

l = StrParametros.l;
Hc = StrParametros.Hc;
Lc = StrParametros.Lc;
Rw = StrParametros.Rw;

if nargin <= 4,
   handler = zeros(10,1);
   handler(1) = rectangle('Position',[x-Lc/2 2*Rw Lc Hc],'FaceColor',[0 0 1],'EraseMode','xor');
   handler(2) = rectangle('Position',[x-2.5*Lc/8-Rw 0 2*Rw 2*Rw],'FaceColor',[0.5 0.5 0.5],'Curvature',[1 1],'EraseMode','xor');
   handler(3) = rectangle('Position',[x+2.5*Lc/8-Rw 0 2*Rw 2*Rw],'FaceColor',[0.5 0.5 0.5],'Curvature',[1 1],'EraseMode','xor');
   handler(4) = line([x x+2*l*cos(theta-pi/2)],[Hc+2*Rw Hc+2*Rw+2*l*sin(theta-pi/2)],'Color','r','linewidth',4,'EraseMode','xor');
   axis([min([StrParametros.xmin-Lc/2,StrParametros.xmin-2*l]) max([StrParametros.xmax+Lc/2,StrParametros.xmax+2*l]) -0.1 Hc+2*Rw+2*l]);
   line([StrParametros.xmin-Lc/2 StrParametros.xmax+Lc/2],[0 0],'Color','k','linewidth',2,'EraseMode','xor');
   line([StrParametros.xmin-Lc/2 StrParametros.xmin-Lc/2],[0 Hc],'Color','k','linewidth',4,'EraseMode','xor');
   line([StrParametros.xmax+Lc/2 StrParametros.xmax+Lc/2],[0 Hc],'Color','k','linewidth',4,'EraseMode','xor');
   for l=1:round((StrParametros.xmax-StrParametros.xmin+Lc)/0.05),
      line([StrParametros.xmin-Lc/2+l*0.05-0.05/2 StrParametros.xmin-Lc/2+(l+1)*0.05-0.05/2],[0 -0.05],'Color','k','linewidth',1,'EraseMode','xor')
	end      
   daspect([1 1 1]);
   set(gca,'Visible','off');
else
   set(handler(1),'Position',[x-Lc/2 2*Rw Lc Hc]);
   set(handler(2),'Position',[x-2.5*Lc/8-Rw 0 2*Rw 2*Rw]);
   set(handler(3),'Position',[x+2.5*Lc/8-Rw 0 2*Rw 2*Rw]);
   set(handler(4),'XData',[x x+2*l*cos(theta-pi/2)],'YData',[Hc+2*Rw Hc+2*Rw+2*l*sin(theta-pi/2)]);
end
