function [StrEstado,StrEntrada,StrMedicao,FimDeCurso] = penduloinvertido_simular(StrEstado,StrEntrada,StrMedicao,StrParametros,F,T,n)

%%% Saturao da entrada:
if F > StrParametros.Fmax,  F = StrParametros.Fmax; end
if F < StrParametros.Fmin,  F = StrParametros.Fmin; end
   
%%% Extrao dos parmetros:
m = StrParametros.m;
M = StrParametros.M;
b = StrParametros.b;
l = StrParametros.l;
I = StrParametros.I;
g = StrParametros.g;
xmax = StrParametros.xmax;
xmin = StrParametros.xmin;
thetamax = StrParametros.thetamax;
thetamin = StrParametros.thetamin;

%%% Extrao das variveis de estado:
x = StrEstado.x(n-1);
xdot = StrEstado.xdot(n-1);
theta = StrEstado.theta(n-1);
thetadot = StrEstado.thetadot(n-1);

%%% Aproximao de Euler como CMEX:
mexEstado = [x,xdot,theta,thetadot];
mexParametros = [m,M,b,l,I,g,xmax,xmin,thetamax,thetamin];

[mexEstado,FimDeCurso] = mexpenduloinvertido(mexEstado,mexParametros,F,T);

StrEstado.x(n) = mexEstado(1);
StrEstado.xdot(n) = mexEstado(2);
StrEstado.theta(n) = mexEstado(3);
StrEstado.thetadot(n) = mexEstado(4);

StrMedicao.x(n) = StrEstado.x(n) + StrParametros.xnoisestd*randn(1);
StrMedicao.theta(n) = StrEstado.theta(n) + StrParametros.thetanoisestd*randn(1);

StrEntrada.u(n) = F;
